SortFilter (Apache Ant API)
Keywords: org.apache.tools.ant.filters.SortFilter class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tools.ant.filters
Class SortFilter

    java.lang.Object
      java.io.Reader
          java.io.FilterReader
              org.apache.tools.ant.filters.BaseFilterReader
                  org.apache.tools.ant.filters.BaseParamFilterReader
                      org.apache.tools.ant.filters.SortFilter

All Implemented Interfaces:
  java.io.Closeable, java.lang.Readable, ChainableReader, Parameterizable

    public final class SortFilter

extends BaseParamFilterReader
implements ChainableReader

Sort a file before and/or after the file.

Examples:

       <copy todir="build">
           <fileset dir="input" includes="*.txt"/>
           <filterchain>
               <sortfilter/>
           </filterchain>
       </copy>

Sort all files `*.txt` from src location and copy them into build location. The lines of each file are sorted in ascendant order comparing the lines via the `String.compareTo(Object o)` method.

       <copy todir="build">
           <fileset dir="input" includes="*.txt"/>
           <filterchain>
               <sortfilter reverse="true"/>
           </filterchain>
       </copy>

Sort all files `*.txt` from src location into reverse order and copy them into build location. If reverse parameter has value `true` (default value), then the output line of the files will be in ascendant order.

       <copy todir="build">
           <fileset dir="input" includes="*.txt"/>
           <filterchain>
               <filterreader classname="org.apache.tools.ant.filters.SortFilter">
                 <param name="comparator" value="org.apache.tools.ant.filters.EvenFirstCmp"/>
               </filterreader>
           </filterchain>
       </copy>

Sort all files `*.txt` from src location using as sorting criterium `EvenFirstCmp` class, that sorts the file lines putting even lines first then odd lines for example. The modified files are copied into build location. The `EventFirstCmp`, has to an instanciable class via `Class.newInstance()`, therefore in case of inner class has to be static. It also has to implement `java.util.Comparator` interface, for example:

             package org.apache.tools.ant.filters;
             ...(omitted)
               public final class EvenFirstCmp implements <b>Comparator</b> {
                 public int compare(Object o1, Object o2) {
                 ...(omitted)
                 }
               }

The example above is equivalent to:

>        <componentdef name="evenfirst"
>                      classname="org.apache.tools.ant.filters.EvenFirstCmp"/>
>        <copy todir="build">
>            <fileset dir="input" includes="*.txt"/>
>            <filterchain>
>                <sortfilter>
>                    <evenfirst/>
>                </sortfilter>
>            </filterchain>
>        </copy>

If parameter `comparator` is present, then `reverse` parameter will not be taken into account.

Since:
  Ant 1.8.0

Field Summary

Fields inherited from class java.io.FilterReader
`in`

Fields inherited from class java.io.Reader
`lock`

Constructor Summary
`SortFilter()` Constructor for "dummy" instances.
`SortFilter(java.io.Reader in)` Creates a new filtered reader.

Method Summary
`void` | `add(java.util.Comparator comparator)` Set the comparator to be used as sorting criterium as nested element.
`java.io.Reader` | `chain(java.io.Reader rdr)` Creates a new SortReader using the passed in Reader for instantiation.
`java.util.Comparator` | `getComparator()` Returns the comparator to be used for sorting.
`boolean` | `isReverse()` Returns `true` if the sorting process will be in reverse order, otherwise the sorting process will be in ascendant order.
`int` | `read()` Returns the next character in the filtered stream.
`void` | `setComparator(java.util.Comparator comparator)` Set the comparator to be used as sorting criterium.
`void` | `setReverse(boolean reverse)` Sets the sorting process will be in ascendant (`reverse=false`) or to descendant (`reverse=true`).

Methods inherited from class org.apache.tools.ant.filters.BaseParamFilterReader
`getParameters, setParameters`

Methods inherited from class org.apache.tools.ant.filters.BaseFilterReader
`getInitialized, getProject, read, readFully, readLine, setInitialized, setProject, skip`

Methods inherited from class java.io.FilterReader
`close, mark, markSupported, ready, reset`

Methods inherited from class java.io.Reader
`read, read`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SortFilter

    public SortFilter()

  Constructor for "dummy" instances.

  See Also:
    `BaseFilterReader.BaseFilterReader()`

### SortFilter

    public SortFilter(java.io.Reader in)

  Creates a new filtered reader.

  Parameters:
    `in` - A Reader object providing the underlying stream. Must not be `null`.

Method Detail

### read

    public int read()
             throws java.io.IOException

  Returns the next character in the filtered stream. If the desired number of lines have already been read, the resulting stream is effectively at an end. Otherwise, the next character from the underlying stream is read and returned.

  Overrides:
    `read` in class `java.io.FilterReader`
  Returns:
    the next character in the resulting stream, or -1 if the end of the resulting stream has been reached
  Throws:
    `java.io.IOException` - if the underlying stream throws an IOException during reading

### chain

    public java.io.Reader chain(java.io.Reader rdr)

  Creates a new SortReader using the passed in Reader for instantiation.

  Specified by:
    `chain` in interface `ChainableReader`
  Parameters:
    `rdr` - A Reader object providing the underlying stream. Must not be `null`.
  Returns:
    a new filter based on this configuration, but filtering the specified reader

### isReverse

    public boolean isReverse()

  Returns `true` if the sorting process will be in reverse order, otherwise the sorting process will be in ascendant order.

  Returns:
    `true` if the sorting process will be in reverse order, otherwise the sorting process will be in ascendant order.

### setReverse

    public void setReverse(boolean reverse)

  Sets the sorting process will be in ascendant (`reverse=false`) or to descendant (`reverse=true`).

  Parameters:
    `reverse` - Boolean representing reverse ordering process.

### getComparator

    public java.util.Comparator getComparator()

  Returns the comparator to be used for sorting.

  Returns:
    the comparator

### setComparator

    public void setComparator(java.util.Comparator comparator)

  Set the comparator to be used as sorting criterium.

  Parameters:
    `comparator` - the comparator to set

### add

    public void add(java.util.Comparator comparator)

  Set the comparator to be used as sorting criterium as nested element.

  Parameters:
    `comparator` - the comparator to set

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD